/*
	Paintable Computing Simulation

	License

	This software (Paintable Computing Simulation and all parts of its 
	source code) is provided "as is", without any warranty and it is 
	the property of its respective authors. Use of this software is 
	free to everyone, except in commercial and/or military purposes 
	without written permission of its authors. Disassembling the 
	executable code of this software is forbidden for any purpose 
	without written permission of its authors.

	If you intend to use any part of the source code of this software 
	or to develop this software any further, you must include this 
	license in every source file and every About box, without changing 
	it; only appending the license is allowed. And if you use any part 
	of the source code of this software, or develop it further, please 
	send an e-mail to its authors.

	Authors of this software are not responsible for any consequences 
	which use of this software, use of any part of its source or its 
	further development may cause.

	All software and parts of source code used in the development of 
	this software are property of their respective owners.

	Good luck,
	Authors

	Authors (alphabetically):
	Fabijan Lukin
		fabijan@gmail.com
		fabijan.lukin@fer.hr
	Fran Pregernik
		fran.pregernik@gmail.com
		fran.pregernik@fer.hr
	Tomislav Sukser
		tomislav.sukser@gmail.com
		tomislav.sukser@zg.t-com.hr
		tomislav.sukser@fer.hr


	Note:
	Paintable computing was firstly introduced in Programming a 
	Paintable Computer written by William Joseph Butera.


    Copyright (c) 2005,2006. All rights reserved.
    4-6/2006

 */
using System;
using System.Collections.Generic;
using System.Text;
using PaintableSimulator.Engine.PaintableComputers.OperatingSystem;
using System.Reflection;

namespace PaintableSimulator.Engine.Resources
{
	/// <summary>
	/// This is one radio packet.
	/// Static function is used to determine will packet be actualy sent.
	/// </summary>
	internal class RadioPacket
	{
		/// <summary>
		/// Initializes a new instance of the <see cref="T:RadioPacket"/> class.
		/// </summary>
		public RadioPacket()
		{
		}

		// Ova funcija odreuje hoe li paket biti poslan
		public static bool WillBeSent(double radioLinkFailurePercent)
		{
			// ToDo: Float je sada Double
			return ((RandomNumberGenerator.GetRandomNumberRange(1, 100)) > radioLinkFailurePercent);
		}

		/// <summary>
		/// packet origin computer
		/// </summary>
		private int originComputerIndex;

		/// <summary>
		/// Gets or sets the index of the origin computer.
		/// </summary>
		/// <value>The index of the origin computer.</value>
		public int OriginComputerIndex
		{
			get { return originComputerIndex; }
			set { originComputerIndex = value; }
		}

	
		/// <summary>
		/// Wireless packet payload
		/// </summary>
		private NetworkPacket payload;

		/// <summary>
		/// Gets or sets the payload.
		/// </summary>
		/// <value>The payload.</value>
		public NetworkPacket Payload
		{
			get { return payload; }
			set { payload = value; }
		}


		/// <summary>
		/// Transmission schedule
		/// </summary>
		private uint sendAfterTick;

		/// <summary>
		/// Gets or sets the send after tick schedule.
		/// </summary>
		/// <value>The send after tick.</value>
		public uint SendAfterTick
		{
			get { return sendAfterTick; }
			set { sendAfterTick = value; }
		}


	}

}
